#include "Fl_Help_View.H"  /* modified FLTK 1.3.4 header */

class MyHelpView : public Fl_Help_View
{
private:
  Fl_Menu_Item *_menu;

public:
  MyHelpView(int X, int Y, int W, int H)
   : Fl_Help_View(X, Y, W, H),
     _menu(NULL)
  { }

  virtual ~MyHelpView() { }

  void menu(Fl_Menu_Item *m) { _menu = m; }
  int is_selected() { return selected; }
  Fl_Help_View *has_current_view() { return current_view; }

protected:
  int handle(int event) {
    if (event == FL_PUSH && Fl::event_button() == FL_RIGHT_MOUSE) {
      _menu[0].flags = (is_selected() || has_current_view() == this) ? FL_MENU_DIVIDER : FL_MENU_INACTIVE|FL_MENU_DIVIDER;

      const Fl_Menu_Item *m = _menu->popup(Fl::event_x(), Fl::event_y());
      if (m) {
        m->do_callback(NULL);
        return 1;
      }
    }
    return Fl_Help_View::handle(event);
  }
};

static MyHelpView *html;

static void do_nothing_cb(Fl_Widget *, void *) { }

static void copy_html_selection_cb(Fl_Widget *, void *) {
  html->end_selection(1);
}

int main(int argc, char *argv[])
{

  Fl_Menu_Item html_menu[] = {
    { " Copy selection  ", 0, copy_html_selection_cb, NULL, FL_MENU_DIVIDER },
    { " Dismiss  ", 0, do_nothing_cb },
    {0}
  };

  /* ... */
  html = new MyHelpView(10, 30, 780, 560);
  html->menu(html_menu);
  /* ... */

  return Fl::run();
}
